
#include <stdio.h>
#include <stdlib.h>


#ifndef SOUNDX_DEF
	#define SOUNDX_DEF

	#include "gamex-file.hpp"
	#include "gamex-buffer.hpp"

	#define PLAY_REWIND		0
	#define PLAY_CONTINUE	1

	class SoundX {
	public:
		SoundX ();
		~SoundX ();
		bool LoadWav (char *filename);
		void InvalidWav (void);
		bool ReadName (File& wav, Buffer &code, char *match_name);
		bool ReadSize (File& wav, Buffer &code, unsigned int &size);
		void CutLength (float new_length);
		unsigned short	GetBPS (void)			{return bits_per_sample;}
		unsigned short	GetNumChannels (void)	{return num_channels;}
		int				GetNumSamples (void)	{return num_samples;}
		int				GetSamplesPerSec (void)	{return samples_per_sec;}
		bool			NeedUpdate (void);
		int				GetIndex (void)			{return dx_index;}
		void			SetIndex (int n)		{dx_index = n;}
		char*			GetData (void)			{return data;}
		bool			GetRefresh (void)		{return dx_refresh;}
		void			SetRefresh (bool r)		{dx_refresh = r;}
	private:
		unsigned int	samples_per_sec;	// Quality (44100, 22050, 11025, 8000, 6000, etc.) 
		unsigned short	bits_per_sample;	// Resolution (8-bit, 16-bit, etc.)
		unsigned short	num_channels;		// Number of channels
		float			length;				// Length of sound (seconds)
		int				num_samples;		// Num Samples = samples_per_sec * length
		int				num_bytes;			// Total Bytes = (bits_per_sample/8) * num_channels * num_samples
		char*			data;

		int				dx_index;			// Direct Sound index
		bool			dx_refresh;			// Direct Sound refresh
	};
#endif

